<?php
/** Execução invalida da Procedure APURAC_GESDIRETA na Apuracao do Faturamento
 */
namespace Faturamento\Logic\ApuracaoFaturamento\Exception;

class ProcedureApuracao extends \Faturamento\Logic\Exception
{


    /**
     * Construtor.
     *
     * Recebe o nome da mensagem cadastrada no setforms.
     *
     * @param string $messageName
     * @param string $message
     * @param int $code
     * @param \Exception|null $previous
     */
    public function __construct($params = null, $message = "", $code = 0, \Exception $previous = null)
    {
        parent::__construct($message, $code, $previous);
        $this->diferencaComensaisFaturados($params);
    }


    /**
     * Retorna o nome da mensagem cadastrada no Setforms para esta excecao.
     *
     * @return string
     */
    public function getMessageName()
    {
        return $this->messageName;
    }


    public function diferencaComensaisFaturados($exception)
    {
        $this->messageName = "msg_diferenca_comensais_faturados_planejamento";
        $data = array(str_replace("ERRO_INCONSEFETIVOS\ Data:", "", $exception));
        $this->setParams($data);
    }


}