<?php
namespace Financeiro\Util;
use \Geral\Entities\Banco;
/**
 * Created by JetBrains PhpStorm.
 * User: alanoliveira
 * Date: 27/06/13
 * Time: 15:43
 * To change this template use File | Settings | File Templates.
 */
class Util
{

    private $_mascara;
    private $_numeroDeNiveis;
    private $_tamanhoDaMascara;
    private $_tamanhoCadaNivel = array();
    private $_tamanhoNivelAcumulado = array();

    public function __construct($nrorg,$cdbanco,$picture) {
        $banco = Banco::findOneByNrorgAndCdBanco($nrorg,$cdbanco);

        $get = "get".ucfirst(strtolower($picture));
        $this->_mascara = str_replace('a', '*', $banco->$get());
        $this->_mascara = str_replace('c', 'C', $this->_mascara);

        $this->_numeroDeNiveis = (substr_count($this->_mascara, '.') + 1);
        $this->_tamanhoDaMascara = strlen(str_replace('.', '', $this->_mascara));
        $niveis = explode('.', $this->_mascara);
        for($i = 0; $i < $this->_numeroDeNiveis; $i++) {
            $this->_tamanhoCadaNivel[$i] = strlen($niveis[$i]);
            if (empty($this->_tamanhoNivelAcumulado)) {
                $this->_tamanhoNivelAcumulado[$i] = strlen($niveis[$i]);
            } else {
                $this->_tamanhoNivelAcumulado[$i] = $this->_tamanhoNivelAcumulado[$i - 1] + strlen($niveis[$i]);
            }
        }
    }

    public function getMascara()
    {
        return $this->_mascara;
    }

    public function getTamanhoDaMascara()
    {
        return $this->_tamanhoDaMascara;
    }

    public function getNumeroDeNiveis()
    {
        return $this->_numeroDeNiveis;
    }

    public function getTamanhoCadaNivel()
    {
        return $this->_tamanhoCadaNivel;
    }

    /**
     * Retorna o codigo na forma da mascara.
     *
     * @param string $codigoarvore Codigo da arvore.
     *
     * @return string
     */
    public function getCodigoComMascara($codigoarvore){

        $mascara = $this->_mascara;
        $novamascara = '';
        $i = 0;
        $count = 0;

        while($count < strlen($codigoarvore)) {
            if ($mascara[$i] !== '.') {
                $novamascara .= $codigoarvore[$count];
                $count++;
            } else {
                $novamascara .= '.';
            }
            $i++;
        }

        return $novamascara;
    }
    public static function mascaraAgencia(){
        $bancos = Banco::findByNrorg(\Geral\Util\Ambiente::getNrorg());

        $bancosComMascara = array();

        /** @var $banco Banco*/
        foreach ($bancos as $banco){

           $bancosComMascara[$banco->getCdbanco()] = $banco->getCdpictagen();
        }
        return json_encode($bancosComMascara);

    }

    public static function mascaraContaCorrente(){
        $bancos = Banco::findByNrorg(\Geral\Util\Ambiente::getNrorg());

        $bancosComMascara = array();

        /** @var $banco Banco*/
        foreach ($bancos as $banco){

            $bancosComMascara[$banco->getCdbanco()] = $banco->getCdpictcont();
        }
        return json_encode($bancosComMascara);

    }

    /** Remove caracteres especiais do campo passado como parámetro
     * @param $campo
     * @throws \Exception
     * @return mixed
     */
    public static function campoCnabValido($campo){


        try { // Remove acentos e cedilha do campo
			$campo = str_replace('º', ' ', $campo);
            $sym = array(
				'À','Á','Ã','Â', 'à','á','ã','â',
				'Ê', 'É',
				'Í', 'í',
				'Ó','Õ','Ô', 'ó', 'õ', 'ô',
				'Ú','Ü',
				'Ç', 'ç',
				'é','ê',
				'ú','ü',
			);
			$chr = array(
				'A', 'A', 'A', 'A', 'a', 'a', 'a', 'a',
				'E' , 'E',
				'I', 'i',
				'O', 'O', 'O', 'o', 'o', 'o',
				'U', 'U',
				'C', 'c',
				'e', 'e',
				'u', 'u',
			);
            $camposValidos = array('A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I',
                'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R',
                'S', 'T', 'U', 'V', 'X', 'W', 'Y', 'Z', ' ',
                '1', '2', '3', '4', '5', '6', '7', '8', '9',
                '0', ',', '.');

			$campo = str_replace($sym, $chr, $campo);
			
            for ($i = 0; $i < strlen($campo); $i++) {
                $char = strtoupper($campo[$i]);
                if (!in_array($char, $camposValidos)) {
                    $campo[$i] = ' ';
                } else
                    $campo[$i] = $char;
            }
            return $campo;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public static function campoCepTel($numero){
        try{
            $numero = preg_replace('/[[:punct:]]/', '', $numero);

            return $numero;
        } catch(\Exception $e){
            throw $e;
        }
    }

    /** // remove qualquer caracter não numérico
     * @param $campo
     * @return mixed
     */
    public static function removeMascaraInscricao($campo){
       return preg_replace("/\\D+/", null, $campo);
    }

    /**
     * @param $codigo
     * @return int
     */
    public static function mod11_b7($codigo){
        $base = 2;
        $soma = 0;
        for($i = strlen($codigo)-1;$i>0;$i--){
            $soma+= intval($codigo[$i])* $base;
            if(++$base>7) $base = 2;
        }
        $rest = $soma % 11;

        if($rest == 0)
            return 0;
        elseif($rest == 1)
            return '1';
                else return 11 - $rest;
    }
}
