/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_OPER                                                     */
/* Tabela : OPERADOR                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 05/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_OPER' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_OPER
GO

CREATE TRIGGER DTULTATU_OPER
ON OPERADOR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'OPERADOR', null, 'CDOPERADOR='+ CDOPERADOR+ ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE OPERADOR
      SET DTULTATUOPER = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(OPERADOR.CDOPERADOR,0) = ISNULL(INSERTED.CDOPERADOR,0));
   END;
END;
GO

UPDATE OPERADOR SET DTULTATUOPER = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUOPER IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUOPER' and
            type = 'D')
   ALTER TABLE OPERADOR DROP CONSTRAINT DEFAULT_DTULTATUOPER
GO

ALTER TABLE OPERADOR ADD CONSTRAINT DEFAULT_DTULTATUOPER
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUOPER
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_OPER','5.01.005';
GO

